// Feel free to hack and implove, but please credit me with original work.
// Mark Atherton, ZL3JVX, 24 Oact 2011

// quick and dirty test card generator

// argv[1] is Callsign, argv[2] is Location 

// ex: test_card ZL3JVX Christchurch

// output file is "tc.bat" and will execute ImageMagick "convert", this will create a load of GIFs

// encode GIFs to MPEG-2 PS using "ffmpeg -f image2 -r 1 -i tc_%02d.gif -y -an -target pal-dvd -b 1000kb tc.mpg"

// Output then needs to be converted from PS to TS

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define PI		3.1415926539
#define DEG(x)	(x * (PI/180.0))

int main(int argc, char *argv[])
{
	int loop;
	FILE *file;

	file = fopen("tc.bat","w");	
	if(file == NULL) return 1;

	// create the test card

	fprintf(file, "convert -size 720x576 xc:white tc_bg.gif\n");

	fprintf(file, "\n");
	fprintf(file, "convert tc_bg.gif -fill \"rgb(192,192,192)\" -draw \"rectangle 20,20 70,180\" tc_bg.gif\n");
	fprintf(file, "convert tc_bg.gif -fill \"rgb(255,255,0)\" -draw \"rectangle 70,20 120,180\" tc_bg.gif\n");
	fprintf(file, "convert tc_bg.gif -fill \"rgb(0,255,255)\" -draw \"rectangle 120,20 170,180\" tc_bg.gif\n");
	fprintf(file, "convert tc_bg.gif -fill \"rgb(0,255,0)\" -draw \"rectangle 170,20 220,180\" tc_bg.gif\n");
	fprintf(file, "convert tc_bg.gif -fill \"rgb(255,0,255)\" -draw \"rectangle 220,20 270,180\" tc_bg.gif\n");
	fprintf(file, "convert tc_bg.gif -fill \"rgb(255,0,0)\" -draw \"rectangle 270,20 320,180\" tc_bg.gif\n");
	fprintf(file, "convert tc_bg.gif -fill \"rgb(0,0,255)\" -draw \"rectangle 320,20 370,180\" tc_bg.gif\n");

	// add call sign

	fprintf(file, "\n");
	fprintf(file, "convert tc_bg.gif -font arial.ttf -pointsize 80 -fill blue -draw \"text 410,100 '%s'\" tc_bg.gif\n", argv[1]);
	fprintf(file, "convert tc_bg.gif -font arial.ttf -pointsize 50 -fill blue -draw \"text 410,160 '%s'\" tc_bg.gif\n", argv[2]);

	// add clock circle, and centre pip

	fprintf(file, "\n");
	fprintf(file, "convert tc_bg.gif -fill white -stroke black -strokewidth 3 -draw \"circle 360,378 360,228\" tc_bg.gif\n");
	fprintf(file, "convert tc_bg.gif -fill black -stroke black -strokewidth 3 -draw \"circle 360,378 360,382\" tc_bg.gif\n");


	fprintf(file, "\n");
	for(loop = 0; loop < 360; loop += 30)	// add 12 ticks to circle to create clock face
	{

		fprintf(file, "convert tc_bg.gif -fill white -stroke black -strokewidth 3 -draw \"line ");
		fprintf(file, "%1.0f,", 360.0 + (-140.0 * sin((DEG((float)loop))))); // end point of radius
		fprintf(file, "%1.0f ", 378.0 + (-140.0 * cos((DEG((float)loop)))));
		fprintf(file, "%1.0f,", 360.0 + (-150.0 * sin((DEG((float)loop))))); // end point of radius
		fprintf(file, "%1.0f", 378.0 + (-150.0 * cos((DEG((float)loop)))));
		fprintf(file, "\" tc_bg.gif\n");

	}

	fprintf(file, "\n");
	for(loop = 0; loop < 360; loop += 6)	// create 60 GIFs with animated hands
	{

		fprintf(file, "\nconvert tc_bg.gif -fill white -stroke black -strokewidth 3 -draw \"line ");
		fprintf(file, "360,378 ");
		
		fprintf(file, "%1.0f,", 360.0 + (-130.0 * sin((DEG((float)loop))))); // end point of radius
		fprintf(file, "%1.0f", 378.0 + (-130.0 * cos((DEG((float)loop)))));
		fprintf(file, "\" tc_%02d.gif", 59-(loop/6));

	}

	fprintf(file, "\n");
	fflush(file);
	fclose(file);

	return(0);
}
